/**
 * push插件
 */

const log = require('frank-node-log')
const JPush = require("jpush-sdk")
const jpush = require(process.cwd() + '/config/' + process.env.NODE_ENV + '/jpush.json')
const client = JPush.buildClient(jpush.appKey, jpush.masterSecret)

module.exports = this

this.jpush = JPush

this.push = (notification, opts) => {
    opts = opts || {}
    let platform = opts.platform || JPush.ALL
    let audience = opts.audience || JPush.ALL

    let extras = opts.extras || {}
    let production = opts.production || true

    client.push().setPlatform(platform)
        .setAudience(audience)
        .setNotification(notification, JPush.ios(notification, 'happy', '+1', null, extras))
        .setOptions(null, null, null, production, null)
        .send(function (err, res) {
            if (err) {
                log.error('推送失败, reason: ' + err.message
                    + ', platform: ' + platform
                    + ', audicence: ' + JSON.stringify(audience)
                    + ', notification: ' + notification)
            } else {
                log.info('推送成功, platform: ' + platform
                    + ', audicence: ' + JSON.stringify(audience)
                    + ', notification: ' + notification)
            }
        })
}